#!/usr/bin/env python2

# xlogin.py  - Starter script for the schlim login manager
#------------------------------------------------------
# 2010.10.20

import os
from subprocess import call, Popen, PIPE, STDOUT

# Get configuration options
from schlim_conf import *
if os.path.isfile('/etc/schlim.conf'):
    execfile('/etc/schlim.conf')

if os.path.isfile(SCHLIMLOG):
    os.rename(SCHLIMLOG, SCHLIMLOG+'~')
if os.path.isfile(SCHLIMEXITCODE):
    os.remove(SCHLIMEXITCODE)

tidy = Popen('/opt/schlim/schlim_tidy.py', stderr=PIPE)
op, err = tidy.communicate()
print err
with open(SCHLIMLOG, 'w') as fh:
    fh.write(err)

fh_log = open(SCHLIMLOG, 'a')
runx = Popen(['xinit', '/opt/schlim/schlim.py', '--', '/usr/bin/X',
        '-nolisten', 'tcp'], stdout=fh_log, stderr=STDOUT)
runx.communicate()
fh_log.close()
print "Session exited, rc =", runx.returncode

try:
    with open(SCHLIMEXITCODE) as fh:
        ecode = fh.read().strip()
except:
    ecode = None

if ecode == '*restart*':
    os.execl('/sbin/reboot', 'reboot')
elif ecode == '*shutdown*':
    os.execl('/sbin/halt', 'reboot')
